/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "usb.h"
#include "uart.h"
#include "usb_req_class.h"

BOOL UartBusy;

void uart_init()
{
	P_SW1 = (P_SW1 & 0x3f) | 0x80;    //USART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4
	SCON = (SCON & 0x3f) | 0x40; 
	AUXR |= 0x40;		//ʱʱ1Tģʽ
	AUXR &= 0xFE;		//1ѡʱ1Ϊʷ
	TL1 = BR(115200);
	TH1 = BR(115200) >> 8;
	TR1 = 1;			//ʱ1ʼʱ
    ES  = 1;    //ж
    REN = 1;    //

    LineCoding.dwDTERate = 0x00c20100;  //115200
    LineCoding.bCharFormat = 0;
    LineCoding.bParityType = 0;
    LineCoding.bDataBits = 8;
}

void uart1_isr() interrupt UART1_VECTOR
{
    if(RI)
    {
        RI = 0;
        TxBuffer[TxWptr++] = SBUF;
    }

    if(TI)
    {
        TI = 0;
        UartBusy = 0;
    }
}

void uart_set_parity(BYTE parity)
{

        switch (parity)
        {
        default:
        case NONE_PARITY:
            SCON = 0x50;
            break;
        case ODD_PARITY:
        case EVEN_PARITY:
        case MARK_PARITY:
            SCON = 0xd8;
            break;
        case SPACE_PARITY:
            SCON = 0xd0;
            break;
        }
}
void uart_set_baud(DWORD baud)
{
    WORD temp;
	temp = (WORD)BR(baud);
    TL1 = temp;
    TH1 = temp >> 8;
}

void uart_polling()
{
    BYTE dat;
    BYTE cnt;

    if (DeviceState != DEVSTATE_CONFIGURED)  //USBûɣֱ˳
        return;

    if (!UsbInBusy && (TxRptr != TxWptr))
    {
        IE2 &= ~0x80;   //EUSB = 0;
        UsbInBusy = 1;
        usb_write_reg(INDEX, 2);
        cnt = 0;
        while (TxRptr != TxWptr)
        {
            usb_write_reg(FIFO2, TxBuffer[TxRptr++]);
            cnt++;
            if (cnt == EP2IN_SIZE) break;
        }
        usb_write_reg(INCSR1, INIPRDY);
        IE2 |= 0x80;    //EUSB = 1;
    }

    if (!UartBusy && (RxRptr != RxWptr))
    {
        dat = RxBuffer[RxRptr++];
        UartBusy = 1;
        switch (LineCoding.bParityType)
        {
        case NONE_PARITY:
        case SPACE_PARITY:
            TB8 = 0;
            break;
        case ODD_PARITY:
            ACC = dat;
            TB8 = !P;
            break;
        case EVEN_PARITY:
            ACC = dat;
            TB8 = P;
            break;
        case MARK_PARITY:
            TB8 = 1;
            break;
        }
        SBUF = dat;

        while (UartBusy);
    }


    if (UsbOutBusy)
    {
        IE2 &= ~0x80;   //EUSB = 0;
        if ((BYTE)(RxWptr - RxRptr) < (BYTE)(256 - EP2OUT_SIZE))
        {
            UsbOutBusy = 0;
            usb_write_reg(INDEX, 2);
            usb_write_reg(OUTCSR1, 0);
        }
        IE2 |= 0x80;    //EUSB = 1;
    }

}
